/* 
 *  gstalker stock charter
 * 
 *  Copyright (c) 1998 Stefan S. Stratigakos
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, 
 *  USA.
 */

#include "myheader.h"
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>


/******************************************************************************************/
void save_indicators()
{
	gchar tstring[250], *tstringpointer;
   	gint tint, tint2;
   	extern GtkWidget *enable_volume_ind_check;
    	extern GtkWidget *enable_moving_ind_check, *moving_value_entry;
    	extern GtkWidget *enable_pnc_check, *enable_pvc_check, *enable_threshold_check;
    	extern GtkWidget *pnc_value_entry, *pvc_value_entry, *threshold_value_entry;
    	extern char *error_message, invalid_moving[], invalid_pnc[], invalid_pvc[];
    	extern char invalid_threshold[];
    	extern int moving, volume;
    	extern float closeroc, threshold, volumeroc;
    	extern display_message(), exit_indicator_window(), save_volume_dat(), save_moving_dat();
    	extern save_closeroc_dat(), save_volumeroc_dat(), save_threshold_dat(), draw();
    	
   	
   	if (GTK_TOGGLE_BUTTON (enable_volume_ind_check)->active)
   	{
   		volume = 1;
   		save_volume_dat();
   	}
   	else
   	{
   		volume = 0;
   		save_volume_dat();
   	}
   	if (GTK_TOGGLE_BUTTON (enable_moving_ind_check)->active)
   	{
   		tstringpointer = gtk_entry_get_text(GTK_ENTRY (moving_value_entry));
   		if (strlen(tstringpointer) != 0)
   		{
   			strcpy(tstring, tstringpointer);
   			tint = strlen(tstring);
   			for (tint2 = 0; tint2 < tint; tint2++)
   			{
   				if (isdigit(tstring[tint2]))
   				{
   				}
   				else
   				{
   					error_message = invalid_moving;
					display_message();
					return;
   				}
   			}
   			moving = atoi(tstring);
   			save_moving_dat();
   		}	
   	}
   	else
   	{
   		moving = 0;
   		save_moving_dat();
   	}
   	if (GTK_TOGGLE_BUTTON (enable_pnc_check)->active)
    	{
    		tstringpointer = gtk_entry_get_text(GTK_ENTRY(pnc_value_entry));
		if (strlen(tstringpointer) != 0)
		{
			strcpy(tstring, tstringpointer);
   			tint = strlen(tstring);
   			for (tint2 = 0; tint2 < tint; tint2++)
   			{
   				if (isdigit(tstring[tint2]))
   				{
   				}
   				else
   				{
   					if (tstring[tint2] != '.')
   					{
   						error_message = invalid_pnc;
						display_message();
						return;
					}
   				}
   			}
   			closeroc = atof(tstring);
   			save_closeroc_dat();
   		}
		else
		{
			error_message = invalid_pnc;
			display_message();
			return;
		}
	}
	if (GTK_TOGGLE_BUTTON (enable_pvc_check)->active)
    	{
    		tstringpointer = gtk_entry_get_text(GTK_ENTRY(pvc_value_entry));
		if (strlen(tstringpointer) != 0)
		{
			strcpy(tstring, tstringpointer);
   			tint = strlen(tstring);
   			for (tint2 = 0; tint2 < tint; tint2++)
   			{
   				if (isdigit(tstring[tint2]))
   				{
   				}
   				else
   				{
   					if (tstring[tint2] != '.')
   					{
   						error_message = invalid_pvc;
						display_message();
						return;
					}
   				}
   			}
   			volumeroc = atof(tstring);
   			save_volumeroc_dat();
   		}
		else
		{
			error_message = invalid_pvc;
			display_message();
			return;
		}
	}
	if (GTK_TOGGLE_BUTTON (enable_threshold_check)->active)
    	{
    		tstringpointer = gtk_entry_get_text(GTK_ENTRY(threshold_value_entry));
		if (strlen(tstringpointer) != 0)
		{
			strcpy(tstring, tstringpointer);
   			tint = strlen(tstring);
   			for (tint2 = 0; tint2 < tint; tint2++)
   			{
   				if (isdigit(tstring[tint2]))
   				{
   				}
   				else
   				{
   					if (tstring[tint2] != '.')
   					{
   						error_message = invalid_threshold;
						display_message();
						return;
					}
   				}
   			}
   			threshold = atof(tstring);
   			save_threshold_dat();
   		}
		else
		{
			error_message = invalid_threshold;
			display_message();
			return;
		}
	}
   	draw();
}
/******************************************************************************************/
void edit_indicators()
{
	char tstring[250];
	GtkWidget *frame, *frame2, *frame3, *frame4, *frame5;
    	GtkWidget *notebook, *ok_button, *cancel_button, *help_button, *nbox, *label, *label2;
    	GtkWidget *vbox, *vbox2, *vbox3, *hbox, *hbox2, *hbox3, *hbox4, *hbox5;
    	extern int moving, volume, edit_indicators_flag, chartflag;
    	extern float closeroc, threshold, volumeroc;
    	extern GtkWidget *edit_indicator_window, *enable_volume_ind_check;
    	extern GtkWidget *enable_moving_ind_check, *moving_value_entry;
    	extern GtkWidget *enable_pnc_check, *enable_pvc_check, *enable_threshold_check;
    	extern GtkWidget *pnc_value_entry, *pvc_value_entry, *threshold_value_entry;
    	extern exit_dialog(), exit_indicator_window(), help_edit_indicator_window();
    	extern char symbol[SYMBOL_SIZE], name[NAME_SIZE];
    
	
	if (chartflag != 1)
		return;
	if (edit_indicators_flag)
	{
		if (volume)
        		gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_volume_ind_check), TRUE);
        	else
        		gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_volume_ind_check), FALSE);
        	if (moving)
        		gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_moving_ind_check), TRUE);
        	else
        		gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_moving_ind_check), FALSE);
        	sprintf(tstring, "%d", moving);
        	gtk_entry_set_text(GTK_ENTRY(moving_value_entry), tstring);
        	if (closeroc)
        		gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_pnc_check), TRUE);
        	else
        		gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_pnc_check), FALSE);
        	sprintf(tstring, "%g", closeroc);
        	gtk_entry_set_text(GTK_ENTRY(pnc_value_entry), tstring);
        	if (volumeroc)
        		gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_pvc_check), TRUE);
        	else
        		gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_pvc_check), FALSE);
        	sprintf(tstring, "%g", volumeroc);
        	gtk_entry_set_text(GTK_ENTRY(pvc_value_entry), tstring);
        	if (threshold)
        		gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_threshold_check), TRUE);
        	else
        		gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_threshold_check), FALSE);
        	sprintf(tstring, "%g", threshold);
        	gtk_entry_set_text(GTK_ENTRY(threshold_value_entry), tstring);
        	
        	strcpy(tstring, "Edit Chart Indicators - ");
		strcat(tstring, name);
		strcat(tstring, " (");
		strcat(tstring, symbol);
		strcat(tstring, ")");
		gtk_window_set_title (GTK_WINDOW (edit_indicator_window), tstring);
        	return;
	}
        edit_indicator_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
        gtk_signal_connect (GTK_OBJECT (edit_indicator_window), "delete_event",
			    GTK_SIGNAL_FUNC (exit_indicator_window), NULL);
	gtk_signal_connect (GTK_OBJECT (edit_indicator_window), "destroy",
			    GTK_SIGNAL_FUNC (exit_indicator_window), NULL);
        gtk_window_set_title (GTK_WINDOW (edit_indicator_window), "Edit Chart Indicators");
        gtk_container_border_width (GTK_CONTAINER (edit_indicator_window), 0);
        gtk_window_position(GTK_WINDOW (edit_indicator_window), GTK_WIN_POS_CENTER);
	gtk_widget_set_usize(GTK_WIDGET (edit_indicator_window), 0, 0);
	strcpy(tstring, "Edit Chart Indicators - ");
	strcat(tstring, name);
	strcat(tstring, " (");
	strcat(tstring, symbol);
	strcat(tstring, ")");
	gtk_window_set_title (GTK_WINDOW (edit_indicator_window), tstring);
	
	nbox = gtk_hbox_new (FALSE, 20);
        gtk_container_add (GTK_CONTAINER (edit_indicator_window), nbox);
        gtk_container_border_width (GTK_CONTAINER (nbox), 10);
        gtk_widget_show (nbox);

	notebook = gtk_notebook_new();
	gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook), GTK_POS_TOP);
      	gtk_box_pack_start (GTK_BOX (nbox), notebook, TRUE, TRUE, 0);
      	gtk_container_border_width (GTK_CONTAINER (notebook), 0);
      	gtk_widget_show(notebook);
      	
      	vbox = gtk_vbutton_box_new ();
      	gtk_vbutton_box_set_spacing_default(5);
      	gtk_vbutton_box_set_layout_default(GTK_BUTTONBOX_START);
      	gtk_container_border_width (GTK_CONTAINER (vbox), 0);
      	gtk_box_pack_start (GTK_BOX (nbox), vbox, FALSE, TRUE, 0);
      	gtk_widget_show (vbox);
      	
      	ok_button = gtk_button_new_with_label("Save");
      	gtk_box_pack_start (GTK_BOX (vbox), ok_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (ok_button), "clicked",
			    GTK_SIGNAL_FUNC (save_indicators), NULL);
	gtk_widget_show (ok_button);
      	
      	cancel_button = gtk_button_new_with_label("Cancel");
      	gtk_box_pack_start (GTK_BOX (vbox), cancel_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
			    GTK_SIGNAL_FUNC (exit_indicator_window), NULL);
      	gtk_widget_show (cancel_button);
      	
      	help_button = gtk_button_new_with_label("Help");
      	gtk_box_pack_start (GTK_BOX (vbox), help_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (help_button), "clicked",
			    GTK_SIGNAL_FUNC (help_edit_indicator_window), NULL);
      	gtk_widget_show (help_button);
      	
      	/*** indicator page ***/
      	
      	vbox2 = gtk_vbox_new (FALSE, 10);
        gtk_container_border_width (GTK_CONTAINER (vbox2), 10);
        gtk_widget_show (vbox2);
        
        frame = gtk_frame_new("Volume:");
      	gtk_container_border_width (GTK_CONTAINER (frame), 0);
      	gtk_box_pack_start (GTK_BOX (vbox2), frame, FALSE, TRUE, 0);
      	gtk_widget_show(frame);
      	
      	hbox = gtk_hbox_new (FALSE, 0);
        gtk_container_add (GTK_CONTAINER (frame), hbox);
        gtk_container_border_width (GTK_CONTAINER (hbox), 5);
        gtk_widget_show (hbox);
        
        enable_volume_ind_check = gtk_check_button_new_with_label("Enable");
        gtk_box_pack_start (GTK_BOX (hbox), enable_volume_ind_check, FALSE, TRUE, 0);
        if (volume)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_volume_ind_check), TRUE);
        gtk_widget_show(enable_volume_ind_check);
        
        frame2 = gtk_frame_new("Moving Average:");
      	gtk_container_border_width (GTK_CONTAINER (frame2), 0);
      	gtk_box_pack_start (GTK_BOX (vbox2), frame2, FALSE, TRUE, 0);
      	gtk_widget_show(frame2);
      	
      	hbox2 = gtk_hbox_new (FALSE, 0);
        gtk_container_add (GTK_CONTAINER (frame2), hbox2);
        gtk_container_border_width (GTK_CONTAINER (hbox2), 5);
        gtk_widget_show (hbox2);
        
        enable_moving_ind_check = gtk_check_button_new_with_label("Enable");
        gtk_box_pack_start (GTK_BOX (hbox2), enable_moving_ind_check, FALSE, TRUE, 0);
        if (moving)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_moving_ind_check), TRUE);
        gtk_widget_show(enable_moving_ind_check);
        
        moving_value_entry = gtk_entry_new();
        gtk_box_pack_start (GTK_BOX (hbox2), moving_value_entry, TRUE, TRUE, 0);
        sprintf(tstring, "%d", moving);
        gtk_entry_set_text(GTK_ENTRY(moving_value_entry), tstring);
        gtk_widget_show(moving_value_entry);
        
      	label = gtk_label_new("Indicators");
      	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox2, label);
      	
      	/*** alerts page ***/
	
	vbox3 = gtk_vbox_new (FALSE, 10);
        gtk_container_border_width (GTK_CONTAINER (vbox3), 10);
        gtk_widget_show (vbox3);
	      	
      	frame3 = gtk_frame_new("Percent Net Change:");
      	gtk_container_border_width (GTK_CONTAINER (frame3), 0);
      	gtk_box_pack_start (GTK_BOX (vbox3), frame3, FALSE, TRUE, 0);
      	gtk_widget_show(frame3);
      	
      	hbox3 = gtk_hbox_new(FALSE, 0);
        gtk_container_add (GTK_CONTAINER (frame3), hbox3);
        gtk_container_border_width (GTK_CONTAINER (hbox3), 5);
        gtk_widget_show (hbox3);
        
        enable_pnc_check = gtk_check_button_new_with_label("Enable");
        gtk_box_pack_start (GTK_BOX (hbox3), enable_pnc_check, FALSE, TRUE, 0);
        if (closeroc)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_pnc_check), TRUE);
        gtk_widget_show(enable_pnc_check);
        
        pnc_value_entry = gtk_entry_new();
        gtk_box_pack_start (GTK_BOX (hbox3), pnc_value_entry, TRUE, TRUE, 0);
        sprintf(tstring, "%g", closeroc);
        gtk_entry_set_text(GTK_ENTRY(pnc_value_entry), tstring);
        gtk_widget_show(pnc_value_entry);
        
        frame4 = gtk_frame_new("Percent Volume Change:");
      	gtk_container_border_width (GTK_CONTAINER (frame4), 0);
      	gtk_box_pack_start (GTK_BOX (vbox3), frame4, FALSE, TRUE, 0);
      	gtk_widget_show(frame4);
      	
      	hbox4 = gtk_hbox_new(FALSE, 0);
        gtk_container_add (GTK_CONTAINER (frame4), hbox4);
        gtk_container_border_width (GTK_CONTAINER (hbox4), 5);
        gtk_widget_show (hbox4);
        
        enable_pvc_check = gtk_check_button_new_with_label("Enable");
        gtk_box_pack_start (GTK_BOX (hbox4), enable_pvc_check, FALSE, TRUE, 0);
        if (volumeroc)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_pvc_check), TRUE);
        gtk_widget_show(enable_pvc_check);
        
        pvc_value_entry = gtk_entry_new();
        gtk_box_pack_start (GTK_BOX (hbox4), pvc_value_entry, TRUE, TRUE, 0);
        sprintf(tstring, "%g", volumeroc);
        gtk_entry_set_text(GTK_ENTRY(pvc_value_entry), tstring);
        gtk_widget_show(pvc_value_entry);
        
        frame5 = gtk_frame_new("Threshold:");
      	gtk_container_border_width (GTK_CONTAINER (frame5), 0);
      	gtk_box_pack_start (GTK_BOX (vbox3), frame5, FALSE, TRUE, 0);
      	gtk_widget_show(frame5);
      	
      	hbox5 = gtk_hbox_new(FALSE, 0);
        gtk_container_add (GTK_CONTAINER (frame5), hbox5);
        gtk_container_border_width (GTK_CONTAINER (hbox5), 5);
        gtk_widget_show (hbox5);
        
        enable_threshold_check = gtk_check_button_new_with_label("Enable");
        gtk_box_pack_start (GTK_BOX (hbox5), enable_threshold_check, FALSE, TRUE, 0);
        if (threshold)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_threshold_check), TRUE);
        gtk_widget_show(enable_threshold_check);
        
        threshold_value_entry = gtk_entry_new();
        gtk_box_pack_start (GTK_BOX (hbox5), threshold_value_entry, TRUE, TRUE, 0);
        sprintf(tstring, "%g", threshold);
        gtk_entry_set_text(GTK_ENTRY(threshold_value_entry), tstring);
        gtk_widget_show(threshold_value_entry);
        
      	label2 = gtk_label_new("Alerts");
      	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox3, label2);
      	
      	GTK_WIDGET_SET_FLAGS(ok_button, GTK_CAN_DEFAULT);
      	gtk_widget_grab_default(ok_button);
      	edit_indicators_flag = 1;
      	gtk_widget_show(edit_indicator_window);
}